unit MagischesQuadrat_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EEingabe: TEdit;
    SGZahlenquadrat: TStringGrid;
    BPruefen: TButton;
    BLoeschen: TButton;
    BSchliessen: TButton;
    BMatrixErzeugen: TButton;
    procedure BSchliessenClick(Sender: TObject);
    procedure BLoeschenClick(Sender: TObject);
    procedure BPruefenClick(Sender: TObject);
    procedure BMatrixErzeugenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

type
  matrix = array[1..5,1..5] of integer; // Feld fr Zahlenquadrat
  reihen = array[1..5] of integer;     // Feld fuer Zeilen- und Spaltensummen

var
  Form1: TForm1;
  n, dia1, dia2: integer;
  zahlenquadrat: matrix;
  zei, spa: reihen;

implementation

{$R *.dfm}

procedure TForm1.BSchliessenClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.BLoeschenClick(Sender: TObject);   // Eingaben loeschen
var
  s,z: integer;
begin
  EEingabe.Clear;
  SGZahlenquadrat.Visible := False;
  with SGZahlenquadrat do for z := 1 to n do
    for s := 1 to n do Cells[s-1,z-1] := '';
end;


procedure MatrixEinlesen(var m: Matrix);   // StringGrid in Matrix einlesen
var s,z: integer;
begin
  with Form1.SGZahlenquadrat do for z := 1 to RowCount do
    for s := 1 to ColCount do m[s,z] := StrToInt(Cells[s-1,z-1]);
end;

procedure summen(n: integer; m: matrix; var zsumme,ssumme: reihen; var d1, d2: integer);
var
  z,s: integer;
begin
  for z := 1 to n do begin     // Ermitteln der Zeilensummen
    zsumme[z] := 0;
    for s := 1 to n do zsumme[z] := zsumme[z] + m[s,z];
  end;
  for s := 1 to n do begin     // Ermitteln der Spaltensummen
    ssumme[s] := 0;
    for z := 1 to n do ssumme[s] := ssumme[s] + m[s,z];
  end;
  d1 := 0;
  d2 := 0;
  for s := 1 to n do begin  // Diagonalensummen ermitteln
    d1 := d1 + m[s,s];
    d2 := d2 + m[n+1-s,s];
  end;
end;

procedure pruefen(zsumme, ssumme: reihen; n, d1, d2: integer); // Summen pruefen
var
  i: integer;
  wahr: boolean;
begin
  wahr := true;
  if not(d1 = d2) then wahr := false;
  for i := 1 to n do
    if not((zsumme[i] = d1) and (ssumme[i] = d2)) then wahr := false;
  if wahr = true then ShowMessage(' Das Zahlenquadrat ist ein magisches Quadrat!')
  else ShowMessage('Das Zahlenquadrat ist kein magisches Quadrat!');  
end;

procedure TForm1.BPruefenClick(Sender: TObject); // Hauptprogramm
begin
  MatrixEinlesen(Zahlenquadrat);
  summen(n,Zahlenquadrat,zei,spa,dia1,dia2);
  pruefen(zei,spa,n,dia1,dia2);
end;

procedure TForm1.BMatrixErzeugenClick(Sender: TObject); // StringGrid erzeugen
begin
  if Form1.EEingabe.Text ='' then begin
    ShowMessage('Bitte geben Sie die Zeilen- und Spaltenanzahl ein!');
    Form1.EEingabe.SetFocus;
    Exit;
  end;
  n := StrToInt(Form1.EEingabe.Text);
  if (n <= 0) or (n > 5) then begin
    ShowMessage('Bitte geben Sie eine Zahl zwischen 1 und 5 ein!');
    Form1.EEingabe.Clear;
    Form1.EEingabe.SetFocus;
    Exit;
  end
  else begin
    Form1.SGZahlenquadrat.ColCount := n;
    Form1.SGZahlenquadrat.RowCount := n;
    Form1.SGZahlenquadrat.Width := n*40;
    Form1.SGZahlenquadrat.Height := n*24;
    Form1.SGZahlenquadrat.Visible := True;
  end;
end;

end.
